
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>SIFT特征--方向赋值与关键点描述 / iVAN</title>

    <meta name="description" content="SIFT特征--方向赋值与关键点描述   一个SIFT关键点拥有三个信息:位置,尺度和方向.前面已经介绍了如何精确定位关键点的位置,通过尺度不变性求极值点,可以使其具有缩放不变的性质.现在来谈谈为特征点指定方向参数,使提取的特征对图像旋转具有不变性,从而实现匹配时图像的旋转无关性.最后,再介绍该用什么样的描述符来表达sift特征.   一.关键点方向分配   SIFT特征的一个关键的特性是旋转不变性,实现旋转不变的基本思想是采用&quot;相对&quot;的概念.利用关键点邻域像素的梯度方向分布特性,我们可以为每个关键点指定方向参数 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">SIFT特征--方向赋值与关键点描述</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>  一个SIFT关键点拥有三个信息：位置，尺度和方向。前面已经介绍了如何精确定位关键点的位置，通过尺度不变性求极值点，可以使其具有缩放不变的性质。现在来谈谈为特征点指定方向参数，使提取的特征对图像旋转具有不变性，从而实现匹配时图像的旋转无关性。最后，再介绍该用什么样的描述符来表达sift特征。</p>
<p> </p>
<p>一、关键点方向分配</p>
<p>  SIFT特征的一个关键的特性是旋转不变性，实现旋转不变的基本思想是采用“相对”的概念。利用关键点邻域像素的梯度方向分布特性，我们可以为每个关键点指定方向参数方向。而后面定义的关键点描述特征符是相对于这个主方向的，因而可以实现匹配时图像的旋转无关性。我们通过梯度直方图统计法来确定关键点的方向，即统计以关键点为原点，利用所有在此区域内的像素点的梯度形成一个方向直方图。</p>
<p>具体说来，对于每个特征点P(x,y,δ,σ)所处高斯图像金字塔的δ组σ层图像，其像素点L(x,y)的梯度：(这里的图像是高斯模糊后的图像，非高斯差分图像)</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMjU1NTQ2Njc=.jpg"></p>
<p>梯度的幅值：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMjU2MTAxNzM=.jpg"></p>
<p>梯度的方向：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMjU2MjczNjg=.jpg"></p>
<p>  直方图的横坐标是梯度方向，共 36 项，每项代表了 10 度的范围；纵坐标是梯度大小，对于归到横坐标上任一项内所有的点，将其梯度大小相加，其和作为纵坐标。下图应该有36项，为了示意只画了8项。(<strong>根据Lowe的建议，直方图统计半径采用3*1.5*σ</strong>)</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMjU2NDQxMDA=.jpg"></p>
<p>从直方图中选出纵坐标值最大的一项所在方向作为该关键点的主方向。如果另一个相当于主峰值 80%能量的峰值时，也将其作为该关键点的方向，称为辅方向。特征点有多个方向的情况下，实际上是在此位置上有多个关键点，他们的方向不同。这些方向可以增强匹配的鲁棒性，Lowe的论文指出大概有15%关键点具有多方向，但这些点对匹配的稳定性至为关键。</p>
<p>另外，为了获得更好的稳定性，可以对关键点邻域的梯度大小进行高斯加权。每相邻三个bin采用高斯加权，根据Lowe的建议，模板采用[0.25,0.5,0.25]，并连续加权两次。</p>
<p> </p>
<p>算法流程：</p>
<p>1.      遍历特征点集合points，搜索每个特征点的邻域，半径为rad，生成含有36柱的方向直方图，梯度直方图范围0~360度，其中每10度一个柱。</p>
<p>2.      利用高斯加权对方向直方图进行两次平滑，增加稳定性</p>
<p>3.      通过峰值比较，求取关键点方向（可能是多个方向）；</p>
<p>4.      通过Taylor展开式对上述峰值进行二次曲线拟合，计算关键点精确方向，即重新计算峰值所在bin的值；</p>
<p>5.      根据bin的值还原角度，作为特征点的方向。</p>
<p> </p>
<p>至此，图像的关键点已检测完毕，每个关键点有三个信息：位置、尺度、方向；同时也就使关键点具备平移、缩放、和旋转不变性。</p>
<p>代码：</p>
<pre>/*计算梯度方向图和梯度幅度图*/
void GaussianPyramid::cal_mag_ort(int i) {
	TotalTimer tm("cal_mag_ort");
	const Mat32f&amp; orig = data[i];
	int w = orig.width(), h = orig.height();
	mag[i] = Mat32f(h, w, 1);			//初始化全1矩阵，mag幅度，ort角度
	ort[i] = Mat32f(h, w, 1);
	REP(y, h) {
		float *mag_row = mag[i].ptr(y),
					*ort_row = ort[i].ptr(y);
		const float *orig_row = orig.ptr(y),        //中间行
					*orig_plus = orig.ptr(y + 1),	//下一行,如果溢出由下面的between控制
					*orig_minus = orig.ptr(y - 1);  //上一行,如果溢出由下面的between控制
		// x == 0:
		mag_row[0] = 0;								//最左边的亦无法计算，当溢出处理
		ort_row[0] = M_PI;							//M_PI为内置的，3.1415926

		REPL(x, 1, w-1) {
			if (between(y, 1, h - 1)) {
				float dy = orig_plus[x] - orig_minus[x],
							dx = orig_row[x + 1] - orig_row[x - 1];		//计算梯度dx,dy
				mag_row[x] = hypotf(dx, dy);							//计算dx,dy的斜边，理解为梯度的幅度
				// approx here cause break working on myself/small*. fix later
				// when dx==dy==0, no need to set ort
				ort_row[x] = fast_atan(dy, dx) + M_PI;					//计算梯度的方向，该夹角为向量与x轴的夹角
			} else {
				mag_row[x] = 0;
				ort_row[x] = M_PI;
			}
		}
		// x == w-1
		mag_row[w-1] = 0;				//最右边的无法计算，当溢出处理
		ort_row[w-1] = M_PI;
	}
}

OrientationAssign::OrientationAssign(
		const DOGSpace&amp; dog, const ScaleSpace&amp; ss,
		const std::vector&lt;SSPoint&gt;&amp; keypoints):
	dog(dog),ss(ss), points(keypoints) {}

vector&lt;SSPoint&gt; OrientationAssign::work() const {
	vector&lt;SSPoint&gt; ret;
	for (auto&amp; p : points) {
		auto major_orient = calc_dir(p);
		for (auto&amp; o : major_orient) {
			ret.emplace_back(p);
			ret.back().dir = o;    //将某个特征点的方向o  赋给ret,注意一个特征点的方向有多个
		}
	}
	return ret;
}

/*梯度方向直方图统计的是该点周围点的36个方向的地图幅值*/
std::vector&lt;float&gt; OrientationAssign::calc_dir(
		const SSPoint&amp; p) const {
	auto&amp; pyramid = ss.pyramids[p.pyr_id];			//当前分辨率图像组，包含多个尺度的高斯滤波图像，赋值见Dog.cc : ScaleSpace函数
	auto&amp; orient_img = pyramid.get_ort(p.scale_id); //orient_img角度图
	auto&amp; mag_img = pyramid.get_mag(p.scale_id);	//mag_img幅度图

	float gauss_weight_sigma = p.scale_factor * ORI_WINDOW_FACTOR;		//统计直方图采用高斯加权，delta是其尺度delta的1.5倍
	int rad = round(p.scale_factor * ORI_RADIUS);			//每个点统计直方图的半径为3*1.5*delta	，delta为当前尺度图高斯滤波窗口的组成部分
	float exp_denom = 2 * sqr(gauss_weight_sigma);
	float hist[ORI_HIST_BIN_NUM];
	static float halfipi = 0.5f / M_PI;
	memset(hist, 0, sizeof(hist));

	// calculate gaussian/magnitude weighted histogram
	// of orientation inside a circle
	for (int xx = -rad; xx &lt; rad; xx ++) {
		int newx = p.coor.x + xx;
		// because mag/ort on the border is zero
		if (! between(newx, 1, pyramid.w - 1)) continue;
		for (int yy = -rad; yy &lt; rad; yy ++) {
			int newy = p.coor.y + yy;
			if (! between(newy, 1, pyramid.h - 1)) continue;
		  // use a circular gaussian window
			if (sqr(xx) + sqr(yy) &gt; sqr(rad)) continue;
			float orient = orient_img.at(newy, newx);
			int bin = round(ORI_HIST_BIN_NUM * halfipi * orient );	//由当前点的梯度方向计算所属哪个bin
			if (bin == ORI_HIST_BIN_NUM) bin = 0;
			m_assert(bin &lt; ORI_HIST_BIN_NUM);

			float weight = expf(-(sqr(xx) + sqr(yy)) / exp_denom);	//exp(-(x^2+y^2)/(2*delta^2))
			hist[bin] += weight * mag_img.at(newy, newx);			//高斯累加当前bin的梯度幅值
		}
	}

	// TODO do we need this?
	// smooth the histogram by interpolation，进行两遍直方图平滑，用前后两个bin去平滑当前bin
	for (int K = ORI_HIST_SMOOTH_COUNT; K --;)
		REP(i, ORI_HIST_BIN_NUM) {
			float prev = hist[i == 0 ? ORI_HIST_BIN_NUM - 1 : i - 1];
			float next = hist[i == ORI_HIST_BIN_NUM - 1 ? 0 : i + 1];
			hist[i] = hist[i] * 0.5 + (prev + next) * 0.25;
		}

	float maxbin = 0;
	for (auto i : hist) update_max(maxbin, i);		//i为每个bin的直方图值，此函数找最大bin，为主方向
	float thres = maxbin * ORI_HIST_PEAK_RATIO;		//辅方向判断阈值
	vector&lt;float&gt; ret;

	REP(i, ORI_HIST_BIN_NUM) {
		float prev = hist[i == 0 ? ORI_HIST_BIN_NUM - 1 : i - 1];
		float next = hist[i == ORI_HIST_BIN_NUM - 1 ? 0 : i + 1];
		// choose extreme orientation which is larger than thres，相当于寻找局部极值(前后3个bin内)
		if (hist[i] &gt; thres &amp;&amp; hist[i] &gt; max(prev, next)) {
			// parabola interpolation,对方向直方图的Taylor展开式进行二次曲线拟合，精确关键点方向: 先找哪个bin，再还原到角度
			real_t newbin = (float)i - 0.5 + (hist[i] - prev) / (prev + next - 2 * hist[i]);
			// I saw this elsewhere... although by derivation the above one should be correct
			//real_t newbin = (float)i - 0.5 + (next - prev) / (prev + next - 2 * hist[i]);
			if (newbin &lt; 0)
				newbin += ORI_HIST_BIN_NUM;
			else if (newbin &gt;= ORI_HIST_BIN_NUM)
				newbin -= ORI_HIST_BIN_NUM;
			float ort = newbin / ORI_HIST_BIN_NUM * 2 * M_PI;
			ret.push_back(ort);	//注意，这里存在多个方向
		}
	}
	return ret;
}</pre>
<p>结果：<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMjU4MDI4NjU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMzAzMzczNzI=.jpg"></p>
<p><strong>上图现实sift特征点数量有1756个</strong></p>
<p>二、特征描述符</p>
<p>  目前为止，我们已经为关键点赋予了坐标位置、尺度信息以及方向。现在我们需要一组向量将这个关键点表达出来，并且这组向量不单包括关键点，还应包括关键点周围对其有贡献的像素点。我们还期望这组向量对仿射变换、光照变换等具有一定的鲁棒性，这些不变特性将会作为目标匹配的依据。</p>
<p>描述子的基本思路：通过对关键点周围图像区域分块，计算块内梯度直方图，生成具有独特性的向量，这个向量是该区域图像信息的一种抽象，具有唯一性。</p>
<p>  如下图所示，左侧图片为在关键点周围取一个8*8邻域，每一个小格都代表了特征点邻域所在的尺度空间的一个像素，箭头方向代表了像素梯度方向，箭头长度代表该像素的幅值。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMjU4NDgyMTE=.jpg"></p>
<p> <br />    右侧图片为四分之一个邻域，由4个大小2*2的像素区域组成，每个子区域生成一个八方向的梯度直方图，绘制每个梯度方向的累加可形成一个种子点。这样一个特征点由4*4个种子点的信息所组成，如下图所示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMjU5MTA2NDA=.jpg"></p>
<p>即每个子区域生成一个描述子，一个描述子中涉及 8 个方向。所以每个关键点有 4x4x8 = 128 维。关键点描述子生成步骤：</p>
<p>1.      确定计算描述子所需的图像区域，图像区域的半径通过下式计算</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMjU5Mjk0MjY=.jpg"></p>
<p>其中，σ<sub>oct</sub>是关键点所在组(octave)的组内尺度，d=4。</p>
<p>2.      将坐标移至关键点主方向，旋转角度后新坐标：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMjU5NTIwNDM=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMzAwMDI5MzE=.jpg"></p>
<p>3.      在图像半径区域内对每个像素点求其梯度幅值和方向，然后对每个梯度幅值乘以高斯权重参数，生成方向直方图。描述子梯度方向直方图由关键点所在尺度的<strong>模糊图像</strong>计算产生。方向直方图的计算如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMzAwMjgzNDA=.jpg"></p>
<p>x<sub>k</sub>：该点与关键点的列距离</p>
<p>y<sub>k</sub>：该点与关键点的行距离</p>
<p>σ<sub>w</sub>：等于描述子窗口宽度3σ*直方图列数（取4）的一半</p>
<p>weight：表示方向直方图某个bin的数值</p>
<p> </p>
<p>4.      在窗口宽度为2X2的区域内计算8个方向的梯度方向直方图，绘制每个梯度方向的累加值，即可形成一个种子点。然后再在下一个2X2的区域内进行直方图统计，形成下一个种子点，共生成16个种子点。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMzAwNTczMTM=.jpg"></p>
<p>5.      描述子向量元素门限化及门限化后的描述子向量规范化。</p>
<p>描述子向量元素门限化是指方向直方图每个方向上梯度幅值限制在一定门限值以下（门限一般取0.2）。</p>
<p>描述子向量元素规范化，即归一化。我们设：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMzAxMjc3MTc=.jpg"></p>
<p>至此，我们就得到了sift特征的128维向量…</p>
<p> </p>
<p>    为什么要做门限化和规范化？为什么要乘以高斯权重参数？</p>
<p>这里用到一些生理学知识，一个生物视觉模型尤其是初级视觉皮层中的复杂神经细胞的工作方式。复杂神经细胞对梯度的方向和空间频率的区分十分敏感，但对视网膜上梯度的位置不作十分精确的区分，允许位置做稍许改变。 1997 年 Edelman， Intrator 和 Poggio 根据这种模型假设复杂神经细胞在视角发生一定变化时，也能够认为物体匹配并识别出 3 维物体。</p>
<p>为了对光线变化更具鲁棒性， 描述子都被归一化到单位长度。如果图像的对比度发生变化，每个像素值都会乘上一个数值，归一化后，对比度的影响被消除了。对于图像亮度的变化，每个像素值都会加上一个数值，然而这对计算的梯度是没有影响的。因此，该描述子对亮度的仿射变换是鲁棒的。对于非线性的光线变化，梯度大小会受影响，但是梯度的方向不会有大的变化，我们可以根据前面描述的生物学原理解决此问题。在 128 维的单位向量中，滤除梯度大小大于0.2的梯度值，然后重新归一化。也就是说，梯度大小的作用被虚弱了，而方向信息的作用被强化了。0.2是实验得出的经验值。</p>
<p>代码：</p>
<pre>SIFT::SIFT(const ScaleSpace&amp; ss,					//ss表示高斯模糊金字塔图像，keypoints表示关键点:位置、尺度、方向
		const vector&lt;SSPoint&gt;&amp; keypoints):
	ss(ss), points(keypoints)
{ }

std::vector&lt;Descriptor&gt; SIFT::get_descriptor() const {
	TotalTimer tm("sift descriptor");
	vector&lt;Descriptor&gt; ret;
	for (auto&amp; p : points) {					//遍历所有特征点，组个计算描述子
		auto desp = calc_descriptor(p);
		ret.emplace_back(move(desp));
	}
	return ret;
}

Descriptor SIFT::calc_descriptor(const SSPoint&amp; p) const {
	static float pi2 = 2 * M_PI;
	static float nbin_per_rad = DESC_HIST_BIN_NUM / pi2;		//一度占多少bin，用于确定某方向属于哪个bin

	const GaussianPyramid&amp; pyramid = ss.pyramids[p.pyr_id];		//获取当前多分辨率多尺度图像金字塔，非dog
	int w = pyramid.w, h = pyramid.h;
	auto&amp; mag_img = pyramid.get_mag(p.scale_id);				//获取当前分辨率每个像素点的梯度方向图和梯度幅度图
	auto&amp; ort_img = pyramid.get_ort(p.scale_id);

	Coor coor = p.coor;											//当前种子特征点坐标和主方向
	float ort = p.dir,
				// size of blurred field of this point in orignal image
				hist_w = p.scale_factor * DESC_HIST_SCALE_FACTOR,	//DESC_HIST_SCALE_FACTOR表示放大倍数，p.scale_factor表示当前高斯模糊图像尺度
				// sigma is half of window width from lowe
				exp_denom = 2 * sqr(DESC_HIST_WIDTH);
	// radius of gaussian to use
	int radius = round(M_SQRT1_2 * hist_w * (DESC_HIST_WIDTH + 1));		//要计算梯度直方图的邻域半径

	float hist[DESC_HIST_WIDTH * DESC_HIST_WIDTH][DESC_HIST_BIN_NUM];  //4*4*8直方图
	memset(hist, 0, sizeof(hist));
	float cosort = cos(ort),
				sinort = sin(ort);										

	//计算当前点邻域内按照各自局部窗口计算方向直方图，共radius/4*radius/4个窗口，窗口大小4*4，8方向
	//并不是说64个像素点绕着原点计算，因为之前已经算过了，每个窗口内将2*2个像素的方向梯度累加到一个点，相当于该窗口有4个种子点
	for (int xx = -radius; xx &lt;= radius; xx ++) {
		int nowx = coor.x + xx;
		if (!between(nowx, 1, w - 1)) continue;
		for (int yy = -radius; yy &lt;= radius; yy ++) {
			int nowy = coor.y + yy;
			if (!between(nowy, 1, h - 1)) continue;
			if (sqr(xx) + sqr(yy) &gt; sqr(radius)) continue;		// to be circle
			// coordinate change, relative to major orientation
			// major orientation become (x, 0)
			float y_rot = (-xx * sinort + yy * cosort) / hist_w,
				  x_rot = (xx * cosort + yy * sinort) / hist_w;//将相对坐标系旋转到种子点主方向，这里是方向图的相对坐标，用于计算局部的梯度幅度
			// calculate 2d bin idx (which bin do I fall into)
			// -0.5 to make the center of bin 1st (x=1.5) falls fully into bin 1st
			float ybin = y_rot + DESC_HIST_WIDTH / 2 - 0.5,			//求取领域内的相对坐标
						xbin = x_rot + DESC_HIST_WIDTH / 2 - 0.5;

			if (!between(ybin, -1, DESC_HIST_WIDTH) ||
					!between(xbin, -1, DESC_HIST_WIDTH)) continue;

			float now_mag = mag_img.at(nowy, nowx),					//nowx,nowy并没有旋转，获取建立高斯金字塔时就计算得到的梯度方向与幅度
						now_ort = ort_img.at(nowy, nowx);
			// gaussian &amp; magitude weight on histogram
			float weight = expf(-(sqr(x_rot) + sqr(y_rot)) / exp_denom);		//方向直方图高斯加权核函数
			weight = weight * now_mag;

			now_ort -= ort;	// for rotation invariance，邻域点方向减去当前特征点方向，再+-180度
			if (now_ort &lt; 0) now_ort += pi2;
			if (now_ort &gt; pi2) now_ort -= pi2;
			// bin number in histogram
			float hist_bin = now_ort * nbin_per_rad;	//最终确定属于哪个bin

			// all three bin idx are float, do trilinear interpolation，累积的
			trilinear_interpolate(
					xbin, ybin, hist_bin, weight, hist); //三线性插值，xbin对应x，ybin对应y，hist_bin对应哪个bin，hist最终可以根据前三个值重新计算梯度的幅度
		}
	}

	// build descriptor from hist,描述子向量元素门限化及门限化后的描述子向量规范化
	Descriptor ret = hist_to_descriptor((float*)hist);
	ret.coor = p.real_coor;
	return ret;
}

	/*
	*
	关键点描述子向量的规范化正是可去除满足此模型的光照影响。
	对于图像灰度值整体漂移 ，图像各点的梯度是邻域像素相减得到，所以也能去除。
	*/
	feature::Descriptor hist_to_descriptor(float* hist) {
		feature::Descriptor ret;
		ret.descriptor.resize(featlen);
		memcpy(ret.descriptor.data(), hist, featlen * sizeof(float));

		// normalize and thresholding and renormalize
		float sum = 0;
		for (auto &amp;i : ret.descriptor) sum += sqr(i);
		sum = sqrt(sum);
		for (auto &amp;i : ret.descriptor) {
			i /= sum;										//规范化
			update_min(i, (float)DESC_NORM_THRESH);			//门限化
		}
		sum = 0;
		for (auto &amp;i : ret.descriptor) sum += sqr(i);
		sum = sqrt(sum);
		sum = (float)DESC_INT_FACTOR / sum;
		for (auto &amp;i : ret.descriptor) i = i * sum;
		return ret;
	}

	void trilinear_interpolate(
			float xbin, float ybin, float hbin,
			float weight, float hist[][DESC_HIST_BIN_NUM]) {
		// WARNING: x,y can be -1
		int ybinf = floor(ybin),
		xbinf = floor(xbin),
		hbinf = floor(hbin);
		float ybind = ybin - ybinf,
					xbind = xbin - xbinf,
					hbind = hbin - hbinf;
		//4*4窗口内再按照2*2累积计算直方图
		REP(dy, 2) if (between(ybinf + dy, 0, DESC_HIST_WIDTH)) {
			float w_y = weight * (dy ? ybind : 1 - ybind);
			REP(dx, 2) if (between(xbinf + dx, 0, DESC_HIST_WIDTH)) {
				float w_x = w_y * (dx ? xbind : 1 - xbind);
				int bin_2d_idx = (ybinf + dy) * DESC_HIST_WIDTH + (xbinf + dx);
				hist[bin_2d_idx][hbinf % DESC_HIST_BIN_NUM] += w_x * (1 - hbind);
				hist[bin_2d_idx][(hbinf + 1) % DESC_HIST_BIN_NUM] += w_x * hbind;
			}
		}
	}
</pre>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTEyMDMyMzAzMDIzODc=.jpg"></p>
<p>由于特征描述子表达的是规范化、门限化后的直方图，再此就不画出这128维直方图了，仅用调用栈信息表达代码执行流程。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 20:07:47</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>SIFT特征--方向赋值与关键点描述的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0QAw0p.html" rel="bookmark">SIFT特征--构造DOG尺度空间</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    最近打算做全景图拼接,尝试过hugin和opencv stitch,一直没有很满意的效果.打算深入研究,恰好,在github看到清华一小哥的项目,故逐步分析他的代码.     sift特征是全景拼接的第一步,相当基础,但sift特征提取与匹配从0开始实现起来又挺折腾的,故花点时间整理下.     清华小哥的博客:http://ppwwyyxx.com/2013/SIFT-and-Image-Stiching/      我的github连接:https://github.com/haop			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YbKqXZp.html" rel="bookmark">sift-已经用opencv对2副图片进行了SIFT特征点匹配，这一对一对的特征点存储在哪里呢，网上找的代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 已经用opencv对2副图片进行了SIFT特征点匹配,这一对一对的特征点存储在哪里呢,网上找的代码 已经用opencv对2副图片进行了SIFT特征点匹配,那么这一对一对的特征点存储在哪里呢,怎么提取其中一对特征点的坐标? #include &quot;stdafx.h&quot; #include #include #include &quot;opencv2/core/core.hpp&quot;//因为在属性中已经配置了opencv等目录,所以把其当成了本地目录一样 #include &qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6vYnM.html" rel="bookmark">矩阵分解-局部特征（比如gabor或sift特征）的低秩矩阵恢复可行吗？有没有实际意义？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 局部特征(比如gabor或sift特征)的低秩矩阵恢复可行吗?有没有实际意义? 我想在原始图像的基础上提取局部的特征(入gabor),并降维,然后以这个作为初始字典进行低秩矩阵恢复或低秩矩阵分解,不知道这样会不会比用全局特征效果好?可行吗?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQLD7Zz.html" rel="bookmark">OpenCV教程&lpar;47&rpar; sift特征和surf特征</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     在前面三篇教程中的几种角检测方法,比如harris角检测,都是旋转无关的,即使我们转动图像,依然能检测出角的位置,但是图像缩放后,harris角检测可能会失效,比如下面的图像,图像放大之前可以检测出为harris角,但是图像放大后,则变成了边,不能检测出角了.所以,harris角是缩放相关的.      在paper Distinctive Image Features from Scale-Invariant Keypoints中,D.Lowe提出了SIFT算法,该算法是缩 放无关的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWQQVp.html" rel="bookmark">sift特征--关键点搜索与定位</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     前面介绍了如何生成高斯图像金字塔,并计算了每组图像的高斯差分图像.现在介绍如何进行关键点搜索与定位(都在灰度图上搞的). 一.极值点计算    关键点是由DOG空间的局部极值点组成的.为了寻找DoG函数的极值点,每一个像素点要和它所有的相邻点比较,看其是否比它的图像域和尺度域的相邻点大或者小. 每一幅高斯差分图像中的一个像素点,要和它同尺度的8个相邻点和上下相邻尺度对应的9×2个点共26个点比较,以确保在尺度空间和二维图像空间都检测到极值点. 具体算法: (1)   遍历不同分辨率和尺			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3888z.html" rel="bookmark">python&plus;OpenCV 特征点检测</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Harris角点检测 Harris角点检测算法是一个极为简单的角点检测算法,该算法在1988年就被发明了,算法的主要思想是如果像素周围显示存在多于一个方向的边,我们认为该点为兴趣点.基本原理是根据公式: 化简为求解矩阵,最后根据矩阵的特征值判断是否为角点 实现效果: 代码(不用OpenCV): # -*- coding: utf-8 -*- from pylab import * from PIL import Image from numpy import * from scipy.ndi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRq0geb.html" rel="bookmark">sift</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介 SIFT算法是用来提取图像局部特征的经典算法,SIFT算法的实质是在不同的尺度空间上查找关键点(特征点),并计算出关键点的方向.SIFT所查找到的关键点是一些十分突出,不会因光照,仿射变换和噪音等因素而变化的点,如角点.边缘点.暗区的亮点及亮区的暗点等.  主要步骤 1.构建DOG尺度空间 2.关键点搜索和定位 3.方向赋值 4.关键点描述子的生成 算法详细流程 ----------------------------------------------------------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p56W66z.html" rel="bookmark">理解SIFT</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				理解SIFT çè§£SIFT MarkdownHTML ## SIFT步骤### 找尺度空间极值 可以用DoG找 需要讲理论依据和DoG结合进行推导 s值和$\sigma$值的选取问题### 关键点定位 和泰勒展开相关### 方向赋值### 局部图像描述符## SIFT用于目标识别的步骤 目标图像提取SIFT特征:搭建SIFT特征数据库 用快速kNN将目标特征在数据库中查找 用霍夫变换寻找属于同一单目标的簇(cluster) 用least-square(最小二乘法)验证## SIFT算法步			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGEJGEM.html" rel="bookmark">OpenCV特征点提取----Fast特征</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.FAST(featuresfrom accelerated segment test)算法   http://blog.csdn.net/yang_xian521/article/details/7411438   特征点检测和匹配是计算机视觉中一个很有用的技术.在物体检测,视觉跟踪,三维常年关键等领域都有很广泛的应用.很多传统的算法都很耗时,而且特征点检测算法只是很多复杂图像处理里中的第一步,得不偿失.FAST特征点检测是公认的比较快速的特征点检测方法,只利用周围像素比较的信息就可以得到特			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJAOVp.html" rel="bookmark" class="title">Cookie的作用</a>
					<div>
						Cookie是什么呢? Cookie可以帮用户保持登录信息,一直到下次与服务器的会话,当下次访问这个网站时,用户会发现没需要重新输入用户名和密码就可以登录了,以便简化登录手续;电子商务网站的&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlvQOz.html" rel="bookmark" class="title">DIY我的个性桌布 用Photoshop设计桌面实例</a>
					<div>
						设计 好多IT企业都有自己独特的自我宣传手段,尤其是一些软件公司,他们会在自己的软件中夹带一些链接或形象桌面等宣传资料,比如像金山公司生产的软件,在用户安装完成后就会提示是否安装金山桌面,这些桌面设计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvV0aM.html" rel="bookmark" class="title">vb&period;net对象的建立和销毁：对象的生命周期</a>
					<div>
						当一个对象被销毁时,Sub Destruct方法被系统自动调用,但不能被显式调用..NEt框架能够在系统自认为一个对象并没有使用价值的时候把该对象销毁.但是切记,不象Class+Terminate和S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4w0B8p.html" rel="bookmark" class="title">Win Vista使用感受：和经典菜单告别</a>
					<div>
						PCWorld主编Harry McCracken近日对测试版的Vista发表了一些自己的使用感受: Windows Vista?我已经连续使用三个月了,我知道微软和所有人都不觉得这么早用Vista是个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPVoKz.html" rel="bookmark" class="title">Java Math 类中的新功能，第 2 部分&colon; 浮点数</a>
					<div>
						Java 语言规范第 5 版向 java.lang.Math 和 java.lang.StrictMath 添加了 10 种新方法,Java 6 又添加了 10 种.这个共两部分的系列文章的 第 1  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4l89p.html" rel="bookmark" class="title">PHP5函数小全</a>
					<div>
						  很多PHP前辈都写了PHP大全,但是我看了发现那些所谓的&quot;大全&quot;根本就不全,甚至比我整理的这个列表内的函数还要少,竟然冠名&quot;大全&quot;,让我不愤,背道而驰,整个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL90Zb.html" rel="bookmark" class="title">XP系统关机时清理页面文件怎么设置</a>
					<div>
						  XP系统关机时清理页面文件怎么设置 1.单击&quot;开始&quot;菜单,单击&quot;运行&quot;,在对话框中输入&quot;Regedit&quot;,然后单击&quot;确定&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBGrQb.html" rel="bookmark" class="title">Windows 8系统中PPPoE宽带连接设置方法</a>
					<div>
						第一步.在网络和共享中心中,单击右侧&quot;更改网络设置&quot;中的&quot;设置新的连接或网络&quot;,选择&quot;连接到Internet&quot;,单击&quot;下一步&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mywowlz.html" rel="bookmark" class="title">迅雷浏览器支持修复失败</a>
					<div>
						  [1]首先登录一个网站,例如迅雷软件中心http://dl.xunlei.com/ 任意点击一个文件下载,看下是否弹出迅雷下载框. ① 如果弹出上面截图的迅雷下载框则可能是迅雷软件问题,可以重装或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJOY2p.html" rel="bookmark" class="title">笔记本电脑电源已接通但显示未充电问题的解决方法</a>
					<div>
						  我一直在使用笔记本电脑,不过用了一年左右了速度也渐渐变慢了,自然是要重装系统的了,我也非常喜欢重装系统,重装之后折腾一下什么的电脑也就和换了新的一样,但是这次我重装系统之后,插上电源他却提示&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvG8r8p.html" rel="bookmark" class="title">浅谈跨网站脚本攻击&lpar;XSS&rpar;的手段与防范&lpar;简析新浪微博XSS攻击事件&rpar;</a>
					<div>
						本文主要涉及内容: 什么是XSS XSS攻击手段和目的 XSS的防范 新浪微博攻击事件 什么是XSS 跨网站脚本(Cross-sitescripting,通常简称为XSS或跨站脚本或跨站脚本攻击)是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EQBxM.html" rel="bookmark" class="title">System&period;Runtime&period;InteropServices&period;COMException &lpar;0x8004E00F&rpar;&colon; COM&plus; 无法与 Microsoft 分布式事务协调程序交谈 &lpar;异常来自 HRESU</a>
					<div>
						错误信息: System.Runtime.InteropServices.COMException (0x8004E00F): COM+ 无法与 Microsoft 分布式事务协调程序交谈 (异常来自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badV9Qz.html" rel="bookmark" class="title">Android彻底组件化方案实践</a>
					<div>
						本文讲的是Android彻底组件化方案实践,一.模块化.组件化与插件化 项目发展到一定程度,随着人员的增多,代码越来越臃肿,这时候就必须进行模块化的拆分.在我看来,模块化是一种指导理念,其核心思想就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2G0Gb.html" rel="bookmark" class="title">azure-虚拟机 2008的系统搭建ftp总是不通，求教</a>
					<div>
						问题描述 虚拟机 2008的系统搭建ftp总是不通,求教 虚拟机 2008的系统搭建ftp总是不通,求大神教我,感激不尽 解决方案 Hi, 请按照这篇文章来检查你的设置是否正确,我试着创建了serve ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWaemp.html" rel="bookmark" class="title">仅createelement所创建的节点的属性</a>
					<div>
						问题描述 仅createelement所创建的节点的属性 这一改变把原来的值也变了,怎么只改变添加的元素的值 解决方案 你这里只创建了ul,好像li也需要创建吧,而且是需要多少创建多少的.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Yln5M.html" rel="bookmark" class="title">源代码-win7下用Java如何编写程序自动修改host文件&comma;</a>
					<div>
						问题描述 win7下用Java如何编写程序自动修改host文件, ,即在程序运行时可输入网址,来屏蔽某些网站,急求源代码,求大神解答 解决方案 这个必须调用其它程序编写的动态库,比如用C++编写一个D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm1Gkz.html" rel="bookmark" class="title">C&plus;&plus;中的左值和右值</a>
					<div>
						在C/C++中,左值(lvalue)和右值(rvalue)是用于规定表达式(expression)的性质.C++中表达式要不然是左值,要不然是右值. 这两个概念在C语言中比较容易理解:左值能放在赋值语 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDW1PBp.html" rel="bookmark" class="title">企业需要警惕 这7种高科技监视技术防不胜防！</a>
					<div>
						钥匙被复制 用长焦镜头从60米外拍摄,或者用智能手机从近处拍照,攻击者能得到万能钥匙或高安全钥匙的清晰照片,再用3D打印机弄个复制品出来,进出公司易如反掌.DEFCON 21 上两名麻省理工大学的学生 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxY0v7p.html" rel="bookmark" class="title">大家推荐一个聊天室？</a>
					<div>
						问题描述 大家推荐一个聊天室?需要.net(c#)的? 解决方案 解决方案二:http://www.51aspx.com/CV/AjaxChatRoom/..........这个不错解决方案三:似乎不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RAw4b.html" rel="bookmark" class="title">java&period;util&period;concurrent包&lpar;1&rpar;&mdash;&mdash;lock和synchronized对比</a>
					<div>
						一.对synchronized的改进 JDK5后引入了线程并发库java.util.concurrent.JSR 166小组花了这么多时间来开发java.util.concurrent.lock框架呢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYBq7p.html" rel="bookmark" class="title">maven构建-求助：Maven构建java项目时出错</a>
					<div>
						问题描述 求助:Maven构建java项目时出错 这个项目以前是用Ant构建的,现在转用Maven了.报错如下:An Ant BuildException has occured: You must  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGE6keM.html" rel="bookmark" class="title">区块链共识机制</a>
					<div>
						本文讲的是区块链共识机制, 原文地址:Consensus 原文作者:The Neo Project 译文出自:掘金翻译计划 本文永久链接:https://github.com/xitu/gold-mi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRGmmb.html" rel="bookmark" class="title">巧用路由当DHCP服务器自动分配IP地址</a>
					<div>
						总公司最近拓展了办公业务,在很多地区成立了子公司.由于子公司 刚刚成立,没有足够的经费购置服务器,而办公用机的IP地址又准备采用DHCP自动分配的方式来进行管理,没有专门的 DHCP服务器就无法实现自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdy7Kmz.html" rel="bookmark" class="title">用组策略修改WIN2003 administrator 的用户名的方法&lowbar;应用技巧</a>
					<div>
						因为我的客户机是XP的用户名是 administrator  我的win2003服务器要启用共享文件,这样我的win2003服务器要用账户 administrator 密码是空,客户机才可以浏览我的共 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgY6aM.html" rel="bookmark" class="title">快速在导航条上移动出现bug</a>
					<div>
						问题描述 快速在导航条上移动出现bug 小弟照极客视频写的一个小demo 当快速在导航条上移动的时候下拉框会出现bug,背景颜色没有了且没有动画效果. 慢慢的移动是可以看见效果的. 正常情况下 不正常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xA65b.html" rel="bookmark" class="title">自己动手写RTP服务器&mdash;&mdash;传输所有格式的视频</a>
					<div>
						上一篇文章我们介绍了如何用一个简单的UDP socket搭建一个RTP服务器.我把这份80行的代码呈现到客户面前的时候,就有人不满意了. 还有人在参考的时候会问:&quot;楼主你的TS格式的文件是哪 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwLA3M.html" rel="bookmark" class="title">求帮助，用C&num; 把XML 写入SQL 数据库！！</a>
					<div>
						问题描述 谢谢了 解决方案 解决方案二:不就是普通的文本字符串嘛.解决方案三:求举个完整的例子我新手解决方案四:非技术区发这帖子..解决方案五:下面这个吗?SQL对Xml字段的操作http://www ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdy56mz.html" rel="bookmark" class="title">一个maven问题求解！百思不得其解！急急急！</a>
					<div>
						问题描述 POM.XML中定义了maven库:======================&lt;repositories&gt;&lt;repository&gt;&lt;id&gt;atlassi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnq9rM.html" rel="bookmark" class="title">马云下棋岁不好&comma;但是热爱布局</a>
					<div>
						阿里巴巴董事会主席马云在其微博上发表了一篇长微博,主要讲述了自己在大学时下围棋的经历,他在长微博中表示,&quot;下围棋让我明白了,我不是下棋的料,知道了天外有天.但我喜欢上了战略布局,中盘角逐,收 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBykqM.html" rel="bookmark" class="title">oracle执行cmd的实现方法&lowbar;oracle</a>
					<div>
						不过有一个简单的执行cmd命令方法: SQL&gt; host net user User accounts for \\PC-ATQHJ4UG1SDA ----------------------- ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
